package cn.ibizlab.businesscentral.core.base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.base.domain.SlaItem;
import cn.ibizlab.businesscentral.core.base.filter.SlaItemSearchContext;
import cn.ibizlab.businesscentral.core.base.service.ISlaItemService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.base.mapper.SlaItemMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[SLA 项] 服务对象接口实现
 */
@Slf4j
@Service("SlaItemServiceImpl")
public class SlaItemServiceImpl extends ServiceImpl<SlaItemMapper, SlaItem> implements ISlaItemService {

    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.base.service.ISlaService slaService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean save(SlaItem et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(SlaItem et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<SlaItem> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<SlaItem> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(SlaItem et) {
        return (!ObjectUtils.isEmpty(et.getSlaitemid()))&&(!Objects.isNull(this.getById(et.getSlaitemid())));
    }
    @Override
    public SlaItem getDraft(SlaItem et) {
        return et;
    }

    @Override
    @Transactional
    public boolean update(SlaItem et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("slaitemid",et.getSlaitemid())))
            return false;
        CachedBeanCopier.copy(get(et.getSlaitemid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<SlaItem> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean create(SlaItem et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getSlaitemid()),et);
        return true;
    }

    @Override
    public void createBatch(List<SlaItem> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public SlaItem get(String key) {
        SlaItem et = getById(key);
        if(et==null){
            et=new SlaItem();
            et.setSlaitemid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }


	@Override
    public List<SlaItem> selectBySlaid(String slaid) {
        return baseMapper.selectBySlaid(slaid);
    }

    @Override
    public void removeBySlaid(String slaid) {
        this.remove(new QueryWrapper<SlaItem>().eq("slaid",slaid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<SlaItem> searchDefault(SlaItemSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<SlaItem> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<SlaItem>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<SlaItem> getSlaitemByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<SlaItem> getSlaitemByEntities(List<SlaItem> entities) {
        List ids =new ArrayList();
        for(SlaItem entity : entities){
            Serializable id=entity.getSlaitemid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}


